unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;

  procedure CloseTest(strMsg: String; withTimer: Boolean = false);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

// Obfuscated error message. It is shown when CBU is missing
// 'SmarxOS(R) Hardware was not found or contains no valid data.'
const STR_MSG_TEST = 'FznekBF(E) Uneqjner jnf abg sbhaq be pbagnvaf ab inyvq qngn.';

var
  Form1: TForm1;

  gl_iBoxIndex : Integer = 1;
  gl_iTestAppId: integer = 999;
  IsCrypToken: Boolean = False;
  testarr: array of Integer;

implementation

uses testutil, sample, testThread, periodicThread;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  self.Close();
end;

procedure TForm1.CloseTest(strMsg: String; withTimer: Boolean = false);
begin
  ShowMessage(strMsg);
  self.Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetNotifications(false);
  SampleEnd;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  res: Boolean;
  H, M, S, MS: word;
  datetime: TDateTime;
  co: TPeriodicThread;
begin
// protection routine
  SampleBegin();
  res := false;
  datetime := Now;

  DecodeTime(datetime, H, M, S, MS);
  //check is triggered if the time is more 11am (11:00):
  if ( H > round(sqrt(sqr(20-9))) ) then begin
    //checking, if MARX key is connected (with CDO):
    res := CBUTest1;
    if res then begin
      SetNotifications(true);
    end else begin
      self.CloseTest(ROT13fun(STR_MSG_TEST));
    end;
  end;

  // Start a thread that checks CBU periodically
  co := TPeriodicThread.Create(true);
  co.FreeOnTerminate := true;
  co.Start;

// end of protection routine

// do some work
Sleep(100);

// protection routine
  if ( H <= round(sqrt(sqr(20-9))) ) then begin
    //checking, if MARX key is connected (with CDO):
    res := CBUTest1;
    if res then begin
      SetNotifications(true);
    end else begin
      self.CloseTest(ROT13fun(STR_MSG_TEST));
    end;
  end;
// end of protection routine

end;

procedure TForm1.FormShow(Sender: TObject);
var
  co: TTestThread;
  res: Boolean;
  H, M, S, MS: word;
  datetime: TDateTime;
begin
// protection routine
  res := false;
  datetime := Now;
  DecodeTime(datetime, H, M, S, MS);
  //check is triggered if the time is more 2pm (14:00):
  if ( H > round(sqrt(200-4)) ) then begin
    //checking, if MARX key is connected (with CDO):
    res := CBUTest1;
    if not res then begin
      //we start a new thread so that the message about disabling the key
      // is issued not immediately after the event occurs,
      // but later for a few seconds:
      co := TTestThread.Create(true);
      co.FreeOnTerminate := true;
      co.Start;
    end;
  end;
// end of protection routine

// do some work
Sleep(100);

// protection routine
  //check is triggered if the time is less 2pm (14:00):
  if ( H <= round(sqrt(200-4)) ) then begin
    //checking, if MARX key is connected (with CDO):
    res := CBUTest1;
    if not res then begin
      //we start a new thread so that the message about disabling the key
      // is issued not immediately after the event occurs,
      // but later for a few seconds:
      co := TTestThread.Create(true);
      co.FreeOnTerminate := true;
      co.Start;
    end;
  end;
// end of protection routine

end;
end.
