{*****************************************************************************
Copyright:   : MARX CryptoTech LP
Project      : CBIOS: CRYPTO-BOX Input/Output System API test
Created      : 01Jul2003
Tools        : Delphi 5 - 2011
Description  : Global constants and variables declaration for CBIOS API test
******************************************************************************
VER         DATE        WHO   DETAIL
******************************************************************************
1.00        01Jul2003   OK    Initial version
1.0.3.701   01Jul2003   OK
1.0.3.703   03Jul2003   OK    Complete test
1.0.3.925   25Sep2003   OK    Changed to match changes in C-based CBIOS
1.0.4.429   29Apr2004   OK    Changed to sample
1.0.4.1006  06Oct2004   OK    Sample revision
1.0.6.715   15Jul2006   GV    Rebuilding with new (local+network) CBIOS.dcu
1.5         22Sep2009   GV    Sample revision for CBIOS 1.5
1.6         06Jun2014   GV    CBU2 was renamed 'CBU SC'
*****************************************************************************}

unit testglobals;

interface

uses cbios;

const
    bUPW: TPasswd = (Ord('d'), Ord('e'), Ord('m'), Ord('o'), $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00);
    bAPW: TPasswd = (Ord('a'), Ord('d'), Ord('m'), Ord('i'), Ord('n'), $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00);

    bNewUPW: TPasswd = (Ord('1'), Ord('2'), Ord('3'), Ord('4'), Ord('5'), Ord('6'), Ord('7'), Ord('8'), $00, $00, $00, $00, $00, $00, $00, $00);
    bNewAPW: TPasswd = (Ord('8'), Ord('7'), Ord('6'), Ord('5'), Ord('4'), Ord('3'), Ord('2'), Ord('1'), $00, $00, $00, $00, $00, $00, $00, $00);

    KEY_S: TByteArr16 = ($B1, $B1, $B2, $B3, $B4, $B5, $B6, $B7, $B8, $B9, $Ba, $Bb, $BB, $Bd, $Be, $Bf);
    IV_S: TByteArr16 = ($21, $21, $22, $23, $24, $25, $26, $27, $28, $29, $2a, $22, $22, $2d, $2e, $2f);

    bNewKEY: TByteArr16 = ($C9, $81, $34, $98, $61, $34, $09, $8F, $D8, $09, $F7, $B1, $29, $29, $76, $9e);
    bNewIV: TByteArr16 = ($d1, $09, $37, $45, $be, $fc, $03, $49, $f7, $12, $58, $ae, $40, $df, $09, $37);

const
    TEST_APP = 999;
    PUBL_OFFSET = 0;
    PRIV_OFFSET = 400;
    MIN_RAM_FOR_RSA = 800;
    DEMO_LABEL = 'macNE';

type
    TCharArr36 = array[0..35] of AnsiChar;

const
    STR_CB_UNKNOWN = 'CRYPTO-BOX Legacy';
    STR_CB_VERSA = 'CRYPTO-BOX Versa';
    STR_CB_XS = 'CRYPTO-BOX XS';
    STR_CB_XL = 'CRYPTO-BOX XL';
    STR_CT_XS = 'CrypToken XS';
    STR_CT_XL = 'CrypToken XL';

    STR_CBU_UNKNOWN = 'Unknown type';
    STR_CBU  = 'CBU';
    STR_CBU2 = 'CBU SC';

implementation

end.







